//Mining machine - reimplemented to add slate behaviour for Rune of Honor quest

//quality flags for mining-machine production
enum machine_production
{
	MINES_BLACKROCK = 1,
	MINES_IRON		= 2,
	MINES_LEAD		= 3,
	MINES_SLATE		= 4
};

MiningMachine 410()
{
	var conveyor;
	var quality;
	var ore_shapes;
	var chosen_shape;

	if(event != DOUBLECLICK) return;

	UI_close_gumps();

	conveyor	= UI_find_nearby(item, SHAPE_CONVEYOR_BELT, 10, 0);
	quality		= UI_get_item_quality(item);

	//machine is broken
	if (quality == 0 || quality > MINES_SLATE)
	{
		UI_execute_usecode_array(item, [0x46, 0x0000, 0x46, 0x0001, 0x58, 0x0025, 0x58, 0x004C]);
		return;
	}
	else
	{
		ore_shapes = [SHAPE_BLACKROCK, SHAPE_IRON_ORE, SHAPE_LEAD_ORE, SHAPE_STONE_CHIPS];
		chosen_shape = ore_shapes[quality];
		UI_execute_usecode_array(item, [0x46, 0x0000, 0x4D, 0x01, 0x58, 0x0008, 0x0C, 0xFFFC, 0x0003, 0x0004, 0x0B, 0xFFF6, 0x0007]);
		UI_execute_usecode_array(conveyor, [0x46, 0x0000, 0x4E, 0x01, 0x58, 0x000F, 0x55, 0x060D, 0x0B, 0xFFF9, 0x0018]);
	}
}

//called as part of MiningMachine animation script, to actually make the ore
ProduceOre 0x60D ()
{
	var mining_machine;
	var quality;
	var ore_shapes;
	var chosen_shape;
	var new_ore;

	var conveyor_pos;
	var conveyor_x;
	var conveyor_y;

	var objs_on_conveyor;
	var num_objs;
	var count;
	var obj;
	var obj_pos;
	var obj_x;
	var obj_y;
	var obj_z;


	if (event != SCRIPTED) return;

	mining_machine = UI_find_nearby(item, SHAPE_MINING_MACHINE, 10, 0);
	quality = UI_get_item_quality(mining_machine);

	ore_shapes		= [SHAPE_BLACKROCK, SHAPE_IRON_ORE, SHAPE_LEAD_ORE, SHAPE_STONE_CHIPS];
	chosen_shape	= ore_shapes[quality];

	conveyor_pos	= UI_get_object_position(item);
	
	//creates an ore chunk
	if (UI_get_random(20) == 1)
	{
		new_ore = UI_create_new_object(chosen_shape);
		if (new_ore)
		{
			UI_set_item_flag(new_ore, TEMPORARY);
			UI_set_item_flag(new_ore, OKAY_TO_TAKE);	//added for completeness' sake (not necessary for machines inside dungeons, where OKAY_TO_TAKE is ignored)

			if (chosen_shape == SHAPE_STONE_CHIPS) UI_set_item_frame(new_ore, FRAME_SLATE);
			else UI_set_item_frame(new_ore, 0);

			UI_update_last_created([conveyor_pos[X] - 9, conveyor_pos[Y], 1]);
		}
	}

	//shifts the ore chunks on the conveyor along

	//objects that are on the conveyor belt
	objs_on_conveyor = UI_find_nearby(item, SHAPE_ANY, 10, 0);
	conveyor_x = conveyor_pos[X];
	conveyor_y = conveyor_pos[Y];

	num_objs = UI_get_array_size(objs_on_conveyor);
	count = 1;

	while (count <= num_objs)
	{
		obj = objs_on_conveyor[count];
		obj_pos = UI_get_object_position(obj);

		obj_x = obj_pos[X];
		obj_y = obj_pos[Y];
		obj_z = obj_pos[Z];

		//object is still on conveyorm, move it along one step
		if (obj_x <= conveyor_x && obj_y == conveyor_y && obj_z == 1)
		{
			if (UI_set_last_created(obj)) UI_update_last_created([obj_x + 1, obj_y, obj_z]);
		}

		//object is at the end of conveyor, drop it off
		else if (obj_x == conveyor_x + 1 && obj_y == conveyor_y && obj_z == 1)
		{
			if (UI_set_last_created(obj)) UI_update_last_created([obj_x, obj_y, 0]);
		}

		count = count + 1;
	}
}