/* This include file contains behaviours for grinding flour from wheat */

//Wheat can be used on a millstone to create a sack of flour
Wheat 677()
{
	var target;
	var target_offsetx;
	var target_offsety;

	//Player double-clicked on wheat-sack - it must first be picked up in order to be used
	if (event == DOUBLECLICK)
	{
		//player is already carrying the sack - call Wheat again with SCRIPTED event
		if (containedByAvatar(item))
		{
			event = SCRIPTED;
			Wheat();
			return;
		}
		else gotoAndGet(item, 0xB06, item, SCRIPTED);
	}

	//Wheat-sack has been acquired and is now ready to use on millstone
	else if (event == SCRIPTED)
	{
		UI_close_gumps();
		target = UI_click_on_item();
		if (UI_get_item_shape(target) != SHAPE_MILLSTONE)
		{
			randomPartySay("\"Why not try grinding the wheat in a millstone?\"");
			return;
		}

		//pathfind to the top edge of the millstone
		target_offsetx = [-1, 0, 1];
		target_offsety = [-5, -5, -5];

		//call millstone() to handle the actual grinding of the wheat
		gotoObject(target, target_offsetx, target_offsety, -3, SHAPE_MILLSTONE, target, SCRIPTED);
	}
}

//Pick up wheat, then continue with regular wheat behaviour (calls Wheat() as an SCRIPTED action)
getWheat 0xB06 ()	{ pickUpItem(item, SHAPE_WHEAT, item, SCRIPTED); }


//Performs grindage upon a sack of wheat
const int SOUND_GRIND = 26;
Millstone 711()
{
	var wheat;
	var direction;
	var use_frame;
	var stand_frame;

	//player double-clicked on the millstone
	if (event == DOUBLECLICK)
	{
		randomPartySay("\"Try grinding wheat upon this millstone.\"");
		return;
	}

	//player used wheat on the millstone
	else if (event == SCRIPTED)
	{
		//find the first wheat sack the player is carrying and remove it
		wheat = UI_get_cont_items(UI_get_avatar_ref(), SHAPE_WHEAT, QUALITY_ANY, FRAME_ANY);
		UI_remove_item(wheat);

		//animate the avatar doing things to the millstone
		direction = directionFromAvatar(item);
		use_frame = getFrame(USE, direction);
		stand_frame = getFrame(STAND, direction);

		script AVATAR
		{
			sfx SOUND_GRIND;
			frame use_frame;
			wait 2;
			frame stand_frame;
			wait 3;

			sfx SOUND_GRIND;
			frame use_frame;
			wait 2;
			frame stand_frame;
			wait 3;

			sfx SOUND_GRIND;
			frame use_frame;
		}

		//call createFlour() at end of animation
		//(we do this in a separate script block, so that the itemref is set properly in the called function)
		script item after 20 ticks	{ call 0xB07; }
	}
}

//Create a new flour sack
createFlour 0xB07()
{
	var flour;
	var target_pos;

	//create the new flour object
	flour = UI_create_new_object(SHAPE_KITCHEN_ITEM);
	if (!flour) return;
	UI_set_item_frame(flour, FRAME_FLOURSACK);

	//figure these out!
	UI_set_item_flag(flour, TEMPORARY);
	UI_set_item_flag(flour, OKAY_TO_TAKE);

	target_pos = UI_get_object_position(item);
	//place it on the middle right-hand side of the millstone
	target_pos[X] = target_pos[X] + 1;
	target_pos[Y] = target_pos[Y] - 3;

	UI_update_last_created(target_pos);
}