/* This file contains include statements for all script modules. It should contain no actual usecode. */
/* In future, this may contain extern statements for all functions defined in included files, to avoid include-priority issues. */

#include "constants/constants.uc";	//constant definitions

#include "general.uc";		//generic functions
#include "npcs/npcs.uc";	//NPC-related functions

#include "items/food.uc";			//Edible items
#include "items/bucket.uc";			//Buckets
#include "items/wheat.uc";			//Grinding wheat
#include "items/kitchenitem.uc";	//Miscellaneous kitchen items
//#include "items/key.uc";			//Keys (commented out for now as behaviour is incomplete)
#include "items/cloth.uc";			//Cloth, thread and looms
#include "items/misc.uc";			//Miscellaneous interactions
#include "items/fishingrod.uc";		//Fishing rod behaviour
#include "items/pocketwatch.uc";	//Corrects am/pm bug
#include "items/shears.uc";			//Added sheep-shearing behaviour

#include "items/miningmachine.uc";	//Reimplemented for Rune of Honour quest

#include "monsters/cow.uc";		//Cows!
#include "monsters/chicken.uc";	//Chickens!
#include "monsters/sheep.uc";	//Sheep!
#include "monsters/fish.uc";	//Fish!

#include "quests/honor.uc";		//Rune of Honor quest

#include "npcs/gordon.uc";			//Gordon the fish-seller's conversation script (adds fish-sales behaviour)
#include "npcs/finnigan.uc";		//Finnegan's conversation script (adds Rune of Honour quest)
#include "npcs/candice.uc";			//Candice's conversation script (adds Rune of Honour quest)
#include "npcs/lordbritish.uc";		//Lord B's conversation script (adds Rune of Honour quest)
#include "npcs/julia.uc";			//Julia's conversation script (adds Rune of Honour quest)
#include "npcs/gladstone.uc";		//Julia's conversation script (adds Rune of Honour quest)

//This line never gets executed, due to a bug in ucc that ignores the last include statement.
//It's only here so that the previous include *will* get executed.
#include "fakeinclude.uc";